Status: Closed Start date: 29 May 2013

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-0.99560 Spent time: 2.00 hours

Description

We should implement functions like IsPrime3 which returns true3/false3 if it easy to calculate, or already calculated, and uncertain3

otherwise.

For example IsZeroDivisor(x) could simply return IsZero(x) if we already know that the ring "IsIntegralDomain", and only otherwise

go through a more expensive computation.

I cannot see a way to do this easily with the "strict" boolean functions we have now.

(This possibly applies to all boolean functions, but that's excessive)

Functions: IsPrime3, IsMaximal3, IsField3, IsIntegralDomain3,...

more?

Related issues:

Related to CoCoALib - Design #498: IsIntegralDomain, IamIntegralDomain3 Closed 28 Mar 2014

Related to CoCoALib - Design #513: Quick/correct flag for bool3 fns In Progress 02 Apr 2014

Related to CoCoALib - Feature #899:  IsMaximal, IsPrimary for IDEAL (in cocoa... Closed 27 Jun 2016

Related to CoCoALib - Feature #885: IsIrred3: fast 3-way irred test (returnin... In Progress 24 May 2016

History

#1 - 29 Oct 2013 15:21 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#2 - 01 Apr 2014 19:18 - Anna Maria Bigatti

- Category set to New Function

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 10

should we follow the same (new flashy) design as for IsIntegralDomain3?

#3 - 01 Apr 2014 19:29 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#4 - 04 Apr 2014 17:15 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#5 - 10 Jul 2014 16:24 - John Abbott

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#6 - 02 Aug 2016 14:21 - Anna Maria Bigatti

- Related to Feature #899:  IsMaximal, IsPrimary for IDEAL (in cocoalib) added

#7 - 02 Aug 2016 15:00 - Anna Maria Bigatti
In a discussion with John Abbott and Mario Albert we got these points

in the case where a bool3 flag is in a class (abstract)

- make the bool3 function as member function?  (but we already have the flag itself at that level; what if its private?)

- make the bool3 function as non-member function? (useful? neccesary?)

- make the bool function as member function:  this fuction is supposed to set the related flag, and also other flags dependent on the result (e.g.

IsPrime)

- make the bool function as non-member function.

- make the member-function actually computing and not reading/setting flags (e.g. myMaximalTest)

(this means I have to change the IamMaximal code accordingly)

#8 - 08 Sep 2016 11:09 - Anna Maria Bigatti

- Status changed from In Progress to Feedback

- % Done changed from 10 to 90

I suggest to close this issue: the discussion about this design has been moved to issue #899 (my mistake, but difficult to move it here)

#9 - 08 Sep 2016 11:16 - Anna Maria Bigatti

- Related to Feature #885: IsIrred3: fast 3-way irred test (returning bool3) added

#10 - 22 May 2017 13:38 - Redmine Admin

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99560

#11 - 25 Nov 2017 10:42 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100
